#include<iostream>
using namespace std;

int main()
{
	ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    
    int n, q;
    cin >> n >> q;
    int d[n], p[n];
    int ukupnaKol = 0;
    for(int i = 0;i<n;i++){
    	cin >> d[i] >> p[i];
    	ukupnaKol+=p[i];
	}
    int k[q];
    for(int i = 0;i<q;i++){
    	cin >> k[i];
	}
    int pojedeno = 0;
    for(int i = 0; i<q; i++){  	
    	for(int j = 0; j<n; j++){
    		if(k[i]>=d[j]){
    			if(k[i]>=p[j]){
    				pojedeno+=p[j];
				}
				else{
					pojedeno += (k[i]-d[j] + 1);
				}
    	}
		}
		if(k[i] > ukupnaKol){
    		pojedeno = ukupnaKol;
		}
		if(k[i]<d[0]){
			pojedeno = 0;
		}
		cout << pojedeno << endl;
	}
    
    
	return 0;
}